//loggers.java Summer 2003, Q1 2004
//Features:
// log levels (file and console)
// sync to disk
// container for app version string

import java.io.*;
//import java.util.Date;

public class loggers extends Thread
{
	static final int version = 5;
	static String versionstring = "xxx";
	
	//Modules
	static config cfg;
	
	static PrintWriter err;
	static int syncseconds = 240;
	static String fileLevel;
	static String consoleLevel;
	static boolean      bOpen = false;
	static boolean bKeepGoing = false;

	public loggers(config cfg)
	{
		this.cfg = cfg;
	
		String errname   = cfg.GetStr("Log", "LogFile");
		if (errname == null) errname = "pocob-log.txt";
		
		syncseconds = cfg.GetInt("Persist", "SyncSeconds", 300);
		fileLevel   = cfg.GetStr("log_file", "all");
		if (fileLevel == null) fileLevel = "x";

		consoleLevel = cfg.GetStr("log_console", "all");
		if (consoleLevel == null) consoleLevel = "x";

		try
		{
			err = new PrintWriter(
				new FileOutputStream(errname, true)
				);

			bOpen = true;
			bKeepGoing = true;
			this.start();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

		String time = (new java.util.Date()).toString();
		Log("I", "<loggers> Log file open: " + time);
		//Log("D", "<loggers> Loaded v" + version);
	}

	public void Log(String level, String text)
	{
		if (consoleLevel.indexOf(level) >= 0)
			System.err.println(level + " " + text);
		
		if (!bOpen) return;
		if (fileLevel.indexOf(level) >= 0)
			err.println(level + " " + text);
	}

	public void LogM(String level, String module, String text)
	{
		text = "<" + module + "> " + text;
	
		String levels = cfg.GetStr("log_console", module);
		if (levels == null && consoleLevel.indexOf(level) >= 0)
			System.err.println(level + " " + text);
		else if (levels.indexOf(level) >= 0)
			System.err.println(level + " " + text);
		
		if (!bOpen) return;
		
		levels = cfg.GetStr("log_file", module);
		if (levels == null && fileLevel.indexOf(level) >= 0)
			err.println(level + " " + text);
		else if (levels.indexOf(level) >= 0)
			err.println(level + " " + text);
	}

	public void run()
	{
		while(bKeepGoing)
		{
			try
			{
				Thread.sleep( syncseconds*1000 );
			}
			catch(InterruptedException e)
			{
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}

			if (bOpen)
			{
				LogM("D", "loggers", "Syncing to disk");
				err.flush();
			}
		}
	}

	public void close()
	{
		if (!bOpen) return;
		err.close();
		bOpen = false;
		bKeepGoing = false;
		this.interrupt();
	}

	//Most classes log stuff, so I figure it is a
	// good place to store the version string
	public void setAppVersion(String versionstring)
	{
		this.versionstring = versionstring;
	}
	
	public String getAppVersion()
	{
		return versionstring;
	}
}
